<template>
  <section>
    <h3>Props</h3>
    <rui-empty v-if="!hasProps" content="This component has no props." inline />
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Required</th>
          <th>Type</th>
          <th>Default</th>
          <th>Allowed values</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <template v-for="(props, group) in propGroups" :key="group">
          <tr v-if="group !== 'default'">
            <th colspan="6" class="-bg-default--alt -ptd">{{ group }}</th>
          </tr>
          <tr v-for="(prop, key) in props" :key="key">
            <td>
              <template v-if="prop.deprecated">
                <del><code>{{ prop.name }}</code></del>
                <p v-if="prop.deprecated === true" class="-text--small -text--color-warning">This prop is deprecated without additional details</p>
                <p v-else class="-text--small -text--color-warning">Deprecated: {{ prop.deprecated }}</p>
              </template>
              <template v-else><code>{{ prop.name }}</code></template>
            </td>
            <td>{{ prop.required ? 'Yes' : '' }}</td>
            <td>{{ prop.type?.name || '-' }}</td>
            <td><code v-if="prop.defaultValue">{{ prop.defaultValue.func ? 'function' : prop.defaultValue.value }}</code></td>
            <td>
              <div v-if="prop.values.length > 0" class="">
                <template v-for="(value, index) in prop.values" :key="value">
                  <code>{{ value }}</code>{{ index < (prop.values.length - 1) ? ', ' : '' }}
                </template>
              </div>
            </td>
            <td><doc-markdown-renderer v-if="prop.description" :raw="prop.description" /></td>
          </tr>
        </template>
      </tbody>
    </table>
  </section>

  <h3>Events</h3>
  <section>
    <rui-empty v-if="!hasEvents" content="This component has no events." inline />
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Description</th>
          <th>Parameters</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(event, key) in doc.events" :key="key">
          <td><code>{{ event.name }}</code></td>
          <td><doc-markdown-renderer v-if="event.description" :raw="event.description" /></td>
          <td>
            <div v-for="property in event.properties" :key="property.name">
              <span class="-text--smaller">
                {<code v-for="type in property.type.names" :key="type">{{ type }}</code>}
              </span>
              <code>{{ property.name }}</code>
              {{ property.description ? `&mdash; ${property.description}` : '' }}
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </section>

  <h3>Slots</h3>
  <section>
    <rui-empty v-if="!hasSlots" content="This component has no slot." inline />
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Description</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(slot, key) in doc.slots" :key="key">
          <td><code>{{ slot.name }}</code></td>
          <td><doc-markdown-renderer v-if="slot.description" :raw="slot.description" /></td>
        </tr>
      </tbody>
    </table>
  </section>
</template>

<script>
import { RuiEmpty } from '../../../src/components/index.js'
import DocMarkdownRenderer from '../../components/MarkdownRenderer/MarkdownRenderer.vue'

export default {
  name: 'ComponentApiView',
  components: { DocMarkdownRenderer, RuiEmpty },
  data () {
    const doc = this.$getDoc(this.$route.params.component)

    return {
      doc,
      hasProps: doc.props.length > 0,
      hasEvents: doc.events.length > 0,
      hasSlots: doc.slots.length > 0,
    }
  },
  computed: {
    propGroups () {
      const groups = { default: [] }

      this.doc.props.forEach((p) => {
        if (!groups[p.group]) groups[p.group] = []
        groups[p.group].push(p)
      })

      return groups
    },
  },
}
</script>
